import javax.swing.*;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;

class LoginDialog extends JDialog {
    private boolean canceled = true;
	private String loginServer, loginPort, loginUser, loginPassword;
    private JOptionPane optionPane;

	public boolean isCanceled() {
        return canceled;
    }
	
	public String getServer() {
        return loginServer;
    }
	
	public String getPort() {
        return loginPort;
    }
	
    public String getUser() {
        return loginUser;
    }
	
	public String getPassword() {
        return loginPassword;
    }
	
	public LoginDialog(Frame aFrame, 
						String server, 
						String port,
						String user,
						String password) {
        super(aFrame, true);
        setTitle("Enter Login Info");
		
        final JLabel serverLabel = new JLabel("Server: ");
        final JLabel portLabel = new JLabel("Port: ");
        final JLabel userLabel = new JLabel("User: ");
        final JLabel passwordLabel = new JLabel("Password: ");
        final JTextField serverField = new JTextField(server, 50);
		final JTextField portField = new JTextField(port, 5);
		final JTextField userField = new JTextField(user, 50);
		final JPasswordField passwordField = new JPasswordField(password, 10);
		
        Object[] array = {serverLabel, serverField,
						  portLabel, portField,
						  userLabel, userField,
						  passwordLabel, passwordField};
						  
        final String btnLogin = "Login";
        final String btnCancel = "Cancel";
        Object[] options = {btnLogin, btnCancel};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.OK_CANCEL_OPTION,
                                    null,
                                    options,
                                    options[0]);
		optionPane.setPreferredSize(new Dimension(200, 220));
		setContentPane(optionPane);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });


        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnLogin)) {
							canceled = false;
                            loginServer = serverField.getText();
							loginPort = portField.getText();
							loginUser = userField.getText();
							// if you have an old JDK version use getText()
							// method instead of getPassword()
							loginPassword = new String(passwordField.getPassword());
                    }		
                    
					setVisible(false);
                }
            }
        });
    }
}
