import javax.swing.*;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;
import com.sybase.dpb.*;
import com.softtreetech.scheduler.*;

class ModifyJobDialog extends JDialog {
    private JOptionPane optionPane;
	private boolean DEBUG;
	private jdpb_24x7 myRemoteControl;
	private String JobID;
	
	public ModifyJobDialog(Frame aFrame, String jobID, String jobName, 
							jdpb_24x7 remote24x7, boolean showDebugMessages) {
        super(aFrame, true);
        setTitle("Modify Job: " + jobName);
		JobID = jobID;
		myRemoteControl = remote24x7;
		DEBUG = showDebugMessages;
		
        final JLabel propLabel = new JLabel("Job Property Name: ");
		Object[] property_list = {	new String("ACCOUNT"),
									new String("AGENT"),
									new String("ASYNC"),
									new String("BACKUP_AGENT"),
									new String("BACKUP_HOST"),
									new String("COMMAND"),
									new String("DAY_NAME"),
									new String("DAY_NUMBER"),
									new String("DELAY"),
									new String("DELETE_RULE"),
									new String("DESCRIPTION"),
									new String("DETACHED"),
									new String("DISABLE_ON_ERROR"),
									new String("DISABLED"),
									new String("END_DATE"),
									new String("END_TIME"),
									new String("FILE"),
									new String("FRIDAY"),
									new String("HOST"),
									new String("IGNORE_ERRORS"),
									new String("INIT_TIMEOUT"),
									new String("INTERVAL"),
									new String("JOB_PASSWORD"),
									new String("JOB_TYPE"),
									new String("KEYSTROKE"),
									new String("LOG"),
									new String("MESSAGE"),
									new String("MONDAY"),
									new String("MONTHLY_TYPE"),
									new String("MSG_ACCOUNT"),
									new String("MSG_DATABASE"),
									new String("MSG_EMAIL"),
									new String("MSG_ERROR"),
									new String("MSG_FILE"),
									new String("MSG_FILE_NAME"),
									new String("MSG_FINISH"),
									new String("MSG_NOTFOUND"),
									new String("MSG_PASSWORD"),
									new String("MSG_PROFILE"),
									new String("MSG_RECIPIENT"),
									new String("MSG_SQL"),
									new String("MSG_START"),
									new String("NAME"),
									new String("NUMBER_OF_RETRIES"),
									new String("PASSWORD"),
									new String("POLLING_INTERVAL"),
									new String("PRIORITY"),
									new String("PROFILE"),
									new String("REBOOT"),
									new String("RETRY_INTERVAL"),
									new String("RETRY_ON_ERROR"),
									new String("SATURDAY"),
									new String("SAVE_ATTACHMENT"),
									new String("SCHEDULE_TYPE"),
									new String("SCRIPT"),
									new String("SEND_KEYSTROKE"),
									new String("SKIP"),
									new String("SKIP_HOLIDAY"),
									new String("SLIDE_HOLIDAY"),
									new String("SQL"),
									new String("START_DATE"),
									new String("START_IN"),
									new String("START_TIME"),
									new String("SUBJECT"),
									new String("SUNDAY"),
									new String("THURSDAY"),
									new String("TIMEOUT"),
									new String("TUESDAY"),
									new String("WEDNESDAY"),
									new String("WINDOW")};
		final JComboBox propList = new JComboBox(property_list);
		propList.setEditable(false);
		final JLabel valueLabel = new JLabel("New Value: ");
		final JTextArea valueField = new JTextArea();
		
		final JScrollPane editor = new JScrollPane(valueField);
        editor.setPreferredSize(new Dimension(200, 200));
		Object[] array = {propLabel, propList, valueLabel, editor};

        final String btnModify = "Modify";
        final String btnDone = "Done";
        Object[] options = {btnModify, btnDone};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.OK_CANCEL_OPTION,
                                    null,
                                    options,
                                    options[0]);
		optionPane.setPreferredSize(new Dimension(250, 350));
		setContentPane(optionPane);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                     Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

					Integer ReturnValue = new Integer(0);
                    if (value.equals(btnModify)) 
					{
						try {
        
							// modify selected property
							if (DEBUG) System.out.println( "Modifying remote job property " + 
								(String)propList.getSelectedItem() + "..." );
		    				setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		    				ReturnValue = myRemoteControl.setjobproperty(JobID, 
																	(String)propList.getSelectedItem(),
																	valueField.getText());
		    				setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		    				if ( ReturnValue.intValue() == 1 ) // success 
							{
								if (DEBUG) System.out.println( "Done" );
							}
							else 
							{
	                        	if (DEBUG) System.out.print( "Error.\n" + 
	    										myRemoteControl.getLasterror());
							}
                    	}//end try
				        catch (com.sybase.dpb.RemoteException e2) {
				           System.err.println( "RemoteException exception: " + e2.getMessage() );
				        }  // end catch 
                    }
					else if (value.equals(btnDone)) 
					{
						// finish dialog
						setVisible(false);
					}
                }
            }
        });
		
		propList.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (isVisible()) {
                    String prop = (String)propList.getSelectedItem();

					Integer ReturnValue = new Integer(0);
					try 
					{
						// get current value
						StringHolder buffer = new StringHolder("");
						if (DEBUG) System.out.println( "Retrieving remote job property " + prop + "..." );
	    				setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	    				ReturnValue = myRemoteControl.getjobproperty(JobID, prop, buffer);
	    				setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	    				if ( ReturnValue.intValue() == 1 ) // success 
						{
							if (DEBUG) System.out.println( "Done" );
							valueField.setText((String)buffer.getValue());
						}
						else 
						{
                        	if (DEBUG) System.out.print( "Error.\n" + 
    										myRemoteControl.getLasterror());
						}
                	}//end try
			        catch (com.sybase.dpb.RemoteException e3) {
			           System.err.println( "RemoteException exception: " + e3.getMessage() );
			        }  // end catch 
                }
            }
        });
    }
}
